unit DrawUtils;
{$codepage UTF8}

interface

uses
    UViews,
    video;

(* This is a custom version of MoveChar that doesn't preserve the original
   attributes in the buffer if attributes equals zero. *)
procedure AddToDrawBuf(
    var buffer: TDrawBuffer;
    character: TEnhancedVideoCell;
    count: SizeInt);

(* Same as above, but allows for setting characters at a specific index. *)
procedure SetInDrawBuf(
    var buffer: TDrawBuffer;
    character: TEnhancedVideoCell;
    position: SizeInt);

procedure InvertColor(var attributes: TEnhancedVideoCell);

implementation

procedure AddToDrawBuf(
    var buffer: TDrawBuffer;
    character: TEnhancedVideoCell;
    count: SizeInt);
var
    P: SizeInt;
begin
    for P := 0 to count do
        buffer[P] := character;
end;

procedure SetInDrawBuf(
    var buffer: TDrawBuffer;
    character: TEnhancedVideoCell;
    position: SizeInt);
begin
    buffer[position] := character;
end;

procedure InvertColor(var attributes: TEnhancedVideoCell);
var
    bg, fg : Byte;
begin
    bg := attributes.BackgroundColor;
    fg := attributes.ForegroundColor;
    attributes.BackgroundColor := fg;
    attributes.ForegroundColor := bg;
end;

end.
